

c64      = 0
c128     = 0
plus4    = 1

setlfs   = $ffba
setnam   = $ffbd
open     = $ffc0
chkin    = $ffc6
chkout   = $ffc9
chrin    = $ffcf
chrout   = $ffd2
readst   = $ffb7
close    = $ffc3
clrchn   = $ffcc
getin    = $ffe4
clall    = $ffe7
ioinit   = $ff84
plot     = $fff0
clrnorm  = $9b

         .if c64
fa       = $ba
blnsw    = $cc
blnon    = $cf

temp     = $6a  ;,b,c,d
iozp     = $70

slidebeg = $18
slideend = $70

screen   = $0400
         .endif


         .if c128
fa       = $ba
setbnk   = $ff68
indfet   = $ff74
indsta   = $ff77

mode     = $d7

blnsw    = $0a27
blnon    = $0a26
curmod   = $0a2b
stavec   = $02b9

temp     = $c8          ;+3 *
iozp     = $a6          ;+1 *

slidebeg = $30
slideend = $88

screen   = $0400
         .endif

         .if plus4
fa       = $ae

blnsw    = $cc
blnon    = $cf

temp     = $6a  ;,b,c,d
iozp     = $70

slidebeg = $18
slideend = $70

screen   = $0c00
         .endif

slide    = $fb
slidec   = $fd



         .if c64
         *= $0800
         ;1998 sys2078:rem...trobe
         .byte $00,$1c,$08,$ce
         .byte $07,$9e,$32,$30
         .byte $37,$38,$3a,$8f
         .byte $14,$14,$14,$14
         .byte $14,$14,$14,$14
         .byte $14,$14,$54,$52
         .byte $4f,$42,$45,$00
         .byte $00,$00

         ;lda $01
         ;and #$7e
         ;sta $01
         .endif


         .if c128
         *= $1c00
        ;1998 graphicclr:sys7201:rem..
         .byte $00,$1f,$1c,$ce
         .byte $07,$de,$9c,$3a
         .byte $9e,$37,$32,$30
         .byte $31,$3a,$8f,$1b
         .byte $50,$1b,$4a,$31
         .byte $39,$39,$38,$20
         .byte $53,$54,$52,$4f
         .byte $42,$45,$00,$00
         .byte $00

         lda #$0e  ;ram0,kernal,io
         sta $ff00

         lda #$00
         tax
         jsr setbnk

         ldy #$11
fnctn1   lda $1000,y
         sta $10ec,y
         lda pfk128,y
         sta $1000,y
         dey
         bpl fnctn1
         .endif

         .if plus4
         *= $1001
         .word basend, 1998
         .byte $9e ; sys
         .text "4126:"
         .byte $8f
         .byte $14,$14,$14,$14
         .byte $14,$14,$14,$14
         .byte $14,$14
         .null "trobe"
basend   .word 0

         ldy #$10
fnctn1   lda pfkplus4,y
         sta $055f,y
         dey
         bpl fnctn1

         .endif

         .ifeq plus4
         ;scpu optimize
         sta $d07e
         sta $d076
         sta $d07f
         .endif

         lda fa
         sta d64dev
         lda #$08
         sta d1541dev

         lda d64mode
         and #$01
         sta intype
         eor #$01
         sta outtype

menu     lda #0
         .ifeq plus4
         sta $d020
         sta $d021
         .endif
         .if plus4
         sta $ff15
         sta $ff19
         .endif
         sta ionum
         sta ionum+1
         sta ionum+2
         sta ionum+3
         ldy d64pathl
         sta d64path,y
         ldy d64namel
         sta d64name,y

         jsr clrchn
         lda #$93 ; ctrl+shift+s
         jsr chrout
         lda #14
         jsr chrout
         lda #8
         jsr chrout

menu1    ldx #<txtm1
         ldy #>txtm1
         jsr ioprint
         lda d1541dev
         sta ionum
         jsr ioprnd

         ldx #<txtm2
         ldy #>txtm2
         jsr ioprint
         lda drive
         sta ionum
         jsr ioprnd

         ldx #<txtm3
         ldy #>txtm3
         jsr ioprint
         lda d64dev
         sta ionum
         jsr ioprnd

         ldx #<txtm4
         ldy #>txtm4
         jsr ioprint
         ldx #<d64path
         ldy #>d64path
         jsr ioprint

         ldx #<txtm5
         ldy #>txtm5
         jsr ioprint

         ldx #<d64name
         ldy #>d64name
         jsr ioprint

         ldx #<txtm6
         ldy #>txtm6
         jsr ioprint

         lda d64mode
         bne menu6a

         ldx #<txtmd0
         ldy #>txtmd0
         jsr ioprint
         jmp menu7

menu6a   ldx #<txtmd1
         ldy #>txtmd1
         jsr ioprint

menu7    ldx #<txtm7
         ldy #>txtm7
         jsr ioprint

menuin   jsr getin
         cmp #0
         beq menuin

menuf1   cmp #133
         bne menuf2
         lda #$93 ; ctrl+shift+s
         jsr chrout
         lda #$24       ;$
         sta iotext
         ldy #1
         lda drive
         asl a
         tax
         lda nums,x
         sta iotext,y
         inx
         iny
         lda nums,x
         cmp #$20
         beq menuf1b
         sta iotext,y
         iny
menuf1b  lda #58        ;:
         sta iotext,y
         iny
         lda #$2a       ;*
         sta iotext,y
         iny
         ldx d1541dev
         jsr iodir
         jmp menu

menuf2   cmp #137
         bne menuf3
menuf2a  inc d1541dev
         ldx d1541dev
         cpx #31
         beq menuf2b
         jsr ioping
         bmi menuf2a
         jmp menu1
menuf2b  ldx #8
         stx d1541dev
         jmp menu1

menuf3   cmp #134
         bne menuf4
         lda #$93 ; ctrl+shift+s
         jsr chrout
         lda #$24
         sta iotext
         ldx #0
         ldy #1
menuf3a  cpx d64pathl
         beq menuf3b
         lda d64path,x
         sta iotext,y
         inx
         iny
         bpl menuf3a
menuf3b  lda #$2a
         sta iotext,y
         iny
         ldx d64dev
         jsr iodir
         jmp menu

menuf4   cmp #138
         bne menuf5
menuf4a  inc d64dev
         ldx d64dev
         cpx #31
         beq menuf4b
         jsr ioping
         bmi menuf4a
         jmp menu1
menuf4b  ldx #8
         stx d64dev
         jmp menu1

menuf5   cmp #135
         bne menuf6
         ldx #<txtm8
         ldy #>txtm8
         jsr ioprint
         jsr ioinput
         sty d64namel
menuf5a  lda iotext,y
         sta d64name,y
         dey
         bpl menuf5a
         jmp menu

menuf6   cmp #139
         bne menuf7  ;8
         lda d64mode
         eor #$01
         sta d64mode
         sta intype
         eor #$01
         sta outtype
         jmp menu1

menuf7   cmp #136
         bne menuf8
         lda #$93 ; ctrl+shift+s
         ;jsr chrout
         lda #$24  ;$
         sta iotext
         ldx #0
         ldy #1
menuf7a  cpx d64pathl
         beq menuf7b
         lda d64path,x
         sta iotext,y
         inx
         iny
         bpl menuf7a
menuf7b  lda #$2a
         sta iotext,y
         iny
         ldx d64dev
         jsr select
         jmp menu

menuf8   cmp #140
         bne menumin
         jsr d64it
         jsr iopause
         jmp menu

menumin  cmp #"-"
         bne menucl
         ldx #<txtma
         ldy #>txtma
         jsr ioprint
         jsr ioinput
         sty d64pathl
menumin1 lda iotext,y
         sta d64path,y
         dey
         bpl menumin1
         jmp menu


menucl   cmp #":"
         bne menuscl
         ldx drive
         dex
         bpl menucla
         ldx #99
menucla  stx drive
         jmp menu1

menuscl  cmp #";"
         bne menuat
         ldx drive
         inx
         cpx #100
         bne menuscla
         ldx #0
menuscla stx drive
         jmp menu1

menuat   cmp #"@"
         bne menustar
         lda d1541dev
         tax
         ldy #$0f
         jsr setlfs

         lda #0
         jsr setnam
         jsr open

         lda d1541dev
         sta ionum
         jsr ioprnd

         ldx #<txtmd
         ldy #>txtmd
         jsr ioprint
         jsr ioinput
         cpy #$00
         beq menuat2
         ldx d1541dev
         lda iotext
         cmp #"$"
         bne menuat0
         jsr iodir
         jmp menuat3
menuat0  jsr chkout
         ldx #$00
menuat1  lda iotext,x
         jsr chrout
         inx
         dey
         bne menuat1
         lda #$0d
         jsr chrout

         jsr clrchn

         lda #$0d
         jsr chrout
menuat2  ldx d1541dev
         jsr ioerror
         ldx #<iotext
         ldy #>iotext
         jsr ioprint
         lda #$0d
         jsr chrout
         jsr iopause
menuat3  lda d1541dev
         jsr close
         jmp menu

menustar cmp #"*"
         bne menurst
         lda d64dev
         tax
         ldy #$0f
         jsr setlfs

         lda #0
         jsr setnam
         jsr open

         lda d64dev
         sta ionum
         jsr ioprnd

         ldx #<txtmd
         ldy #>txtmd
         jsr ioprint
         jsr ioinput
         cpy #$00
         beq menust2
         ldx d64dev
         lda iotext
         cmp #"$"
         bne menust0
         jsr iodir
         jmp menust3
menust0  jsr chkout
         ldx #$00
menust1  lda iotext,x
         jsr chrout
         inx
         dey
         bne menust1
         lda #$0d
         jsr chrout
         jsr clrchn
         lda #$0d
         jsr chrout
menust2  ldx d64dev
         jsr ioerror
         ldx #<iotext
         ldy #>iotext
         jsr ioprint
         lda #$0d
         jsr chrout
         jsr iopause
menust3  lda d64dev
         jsr close
         jmp menu

menurst  cmp #$d1
         bne menuquit
         .if c64
         lda #$37
         sta $01
         lda #$08
         sta $de00
         jmp $fce2
         .endif

         .if c128
         lda #$00  ;bank15
         sta $ff00
         sta $d030
         ldy #$11
menurst1 lda $10ec,y
         sta $1000,y
         dey
         bpl menurst1
         sei
         jsr ioinit
         cli
         jmp $4000
         .endif

         .if plus4
         sei
         sta $ff3e
         jmp ($fffc)
         .endif

menuquit cmp #"q"
         beq *+5
         jmp menu

         lda #9
         jsr chrout

         ;cleanup?
        ;jsr clall

         lda #$00
         ldx #$08
menuquiu sta $68,x
         dex
         bpl menuquiu

         .if c64
         lda $01
         ora #$01
         sta $01
         .endif

         .if c128
         lda #$00  ;bank15
         sta $ff00
         sta $d030
         ldy #$11
fnctn3   lda $10ec,y
         sta $1000,y
         dey
         bpl fnctn3
         .endif

	.ifeq plus4
         ;scpu deoptimize
         sta $d07e
         sta $d077
         sta $d07f
	.endif
         rts

txtm1    .byte $13, $99

         .if c64
               ;123456789012345678901
         .text "             "
         .text "d64it v1.00beta"
         .endif
         .if c128
               ;123456789012345678901
         .text "          "
         .text "d64it-128 v1.00beta"
         .endif
         .if plus4
               ;123456789012345678901
         .text "         "
         .text "d64it-plus4 v1.00beta"
         .endif

         .byte 13,13
         .text "     (C) Strobe 1998 "
         .text "Errol Smith"
         .if plus4
         .byte 13,13
         .text "      plus/4 port by "
         .text "Imre Szell"
         .endif
         .byte 13,13, 5
         .text "  "
         .text "f1"
         .byte clrnorm
         .text " Show 1541 dir"
         .byte 13, 5
         .text "  "
         .text "f2"
         .byte clrnorm
         .text " 1541 device  : "
         .byte 5, 0

txtm2    .byte 32,13, 5
         .text "  "
         .text ":;"
         .byte clrnorm
         .text " partition/drv: "
         .byte 5, 0


txtm3    .byte 32,13, 5
         .text "  "
         .text " @"
         .byte clrnorm
         .text " 1541 dos cmd"
         .byte 13, 5
         .text "  "
         .text "f3"
         .byte clrnorm
         .text " Show d64 dir"
         .byte 13, 5
         .text "  "
         .text "f4"
         .byte clrnorm
         .text " D64 device   : "
         .byte 5, 0

txtm4    .byte 32,13
         .text "   -"
         .byte clrnorm
         .text " D64 path     : "
         .byte 5, 0

txtm5    .byte 13, 5
         .text "  f5"
         .byte clrnorm
         .text " D64 name     : "
         .byte 5, 0

txtm6    .byte 13
         .text "   *"
         .byte clrnorm
         .text " D64 dos cmd"
         .byte 13, 5
         .text "  f6"
         .byte clrnorm
         .text " Mode         : "
         .byte 5, 0

txtm7    .byte 13, 5
         .ifeq plus4
         .text "  f8"
         .endif
         .if plus4
         .text "help"
         .endif
         .byte clrnorm
         .text " D64 it!"
         .byte 13, 5
         .text "   q"
         .byte clrnorm
         .text " quit ("
         .byte 5, "Q", clrnorm
         .text " reset)"
         .byte 13,13
         .text " Use at your own risk!"
         .byte 13,13,5,0

txtm8    .byte clrnorm
         .text "New d64 name : "
         .byte 5, 0

txtma    .byte clrnorm
         .text "New d64 path   : "
         .byte 5, 0

txtmd    .text "> "
         .byte 0

txtmd0   .text "d64 to 1541 disk"
         .byte 0

txtmd1   .text "1541 to d64 file"
         .byte 0

         .if c128
pfk128   .byte 1,1,1,1,1,1,1,1,0,0
         .byte 133,137,134,138
         .byte 135,139,136,140
         .endif

         .if plus4
pfkplus4 .byte 1,1,1,1,1,1,1,1
         .byte 133,137,134,138
         .byte 135,139,136,140
         .endif

        ;x=dev,y=len of dirname
select
         sty iotemp

         lda #$01
         ;ldx #$08
         ldy #$00
         jsr setlfs
         lda iotemp
         ldx #<iotext
         ldy #>iotext
         jsr setnam
         jsr open

         jsr readst
         beq *+3
         rts

         jsr clrchn
         ldx #$01
         jsr chkin

         lda #slidebeg
         sta slide+1
         sta slidec+1
         sta selstart
         lda #$00
         sta slide
         sta slidec

         ;load addres
         jsr chrin
         jsr chrin

         ;skipheader
         jsr chrin
         jsr chrin
         jsr chrin
         jsr chrin
select0  jsr chrin
         bne select0


select1  ldy #$1f
         lda #$20
select1a sta (slide),y
         dey
         bpl select1a

         ;line pointer
         jsr chrin
         jsr chrin

         ;line #
         jsr chrin
         sta ionum
         jsr chrin
         sta ionum+1
         lda #0
         sta ionum+2
         sta ionum+3
         lda #10
         sta ionum+4

         ldx #10
select1b stx iotemp
         jsr iodiv32
         ldx iotemp
         clc
         adc #48
         sta iotmpc,x
         dex
         bne select1b

select1c inx
         lda iotmpc,x
         cmp #48
         beq select1c

         ldy #0
         cpx #11
         bne select1e
         lda #48
         dex
select1e sta (slide),y
         iny
         inx
         lda iotmpc,x
         cpx #11
         bne select1e

select1f jsr readst
         bne selectx

         jsr chrin
         cmp #$22  ;"
         bne select1f

         ldy #$06
select1g jsr chrin
         cmp #$22
         beq select1h
         sta (slide),y
         iny
         bne select1g

select1h jsr chrin
         cmp #$20
         beq select1h

         ldy #$17
select1i sta (slide),y
         iny
         jsr chrin
         bne select1i

         ldy #$1a  ;kludge

         sta (slide),y ;0

         lda slide
         clc
         adc #$20
         sta slide
         bcc *+4
         inc slide+1

         jmp select1


selectx  lda #$01
         jsr close
         jsr clrchn

         lda #$93 ; ctrl+shift+s
         jsr chrout

         lda #0
         sta selhrow
selectm0 jsr selectd

selectm1 jsr getin
         cmp #0
         beq selectm1

         cmp #17   ;dn
         bne selectm3
         inc selhrow
         lda #16
         cmp selhrow
         bne selectm0
         inc selstart

         lda slide+1
         cmp selstart
         bcs selectm2
         sta selstart
         jmp selectm0
selectm2 lda #8
         sta selhrow
         jmp selectm0

selectm3 cmp #145          ;up
         bne selectm5
         dec selhrow
         bpl selectm0
         dec selstart
         lda #slidebeg
         cmp selstart
         bcc selectm4
         beq selectm4
         sta selstart
         inc selhrow
         jmp selectm0
selectm4 lda #7
         sta selhrow
         jmp selectm0

selectm5 cmp #157       ;left
         bne selectm7
         dec selstart
         lda #slidebeg
         cmp selstart
         bcc selectm0
         beq selectm6
         ldy #0
         sty selhrow
selectm6 sta selstart
         jmp selectm0

selectm7 cmp #29        ;right
         bne selectm9
         inc selstart
         jmp selectm0

selectm9
         rts

         ;display list..

         ;fix it to only redisplay
         ;changed stuff
selectd
         lda #$93
         jsr chrout
         lda selstart
         sta slidec+1
         lda #0
         sta selrow
         sta slidec

selectd1 ldx selrow
         ldy #4
         jsr plot

         ldx selrow
         cpx selhrow
         bne *+7
         lda #18
         jsr chrout

         ldy #0
selectd2 lda (slidec),y
         beq selectd3
         jsr chrout
         iny
         bne selectd2

selectd3 ldx selrow
         cpx selhrow
         bne *+7
         lda #146
         jsr chrout

         lda slidec
         clc
         adc #$20
         sta slidec
         bcc *+4
         inc slidec+1

         lda slide
         cmp slidec
         bne *+8
         lda slide+1
         cmp slidec+1
         beq selectdx

         inc selrow
         lda selrow
         cmp #16
         bne selectd1

selectdx
         rts

seltmp   .word 0,0
selrow   .byte 0
selhrow  .byte 0
selstart .byte 0

         ;show directory x=device
iodir    sty iotemp
         lda #$01
         ;ldx #$08
         ldy #$00
         jsr setlfs
         lda iotemp
         ldx #<iotext
         ldy #>iotext
         jsr setnam
         jsr open

         jsr readst
         beq *+3
         rts

         jsr clrchn
         ldx #$01
         jsr chkin

         jsr chrin
         jsr chrin

iodir0   lda #13
         jsr chrout

         ;pause if key
         jsr clrchn
         jsr getin
         cmp #$00
         beq iodir1
         cmp #$03
         beq iodirx
         jsr iopause
iodir1   ldx #$01
         jsr chkin

         jsr chrin
         jsr chrin
         jsr chrin
         sta ionum
         jsr chrin
         sta ionum+1
         jsr readst
         bne iodirx

         ;print blocks
         lda #0
         sta ionum+2
         sta ionum+3
         jsr ioprnd

         lda #32
         jsr chrout

iodir2   jsr chrin
         beq iodir0
         jsr chrout
         bne iodir2

iodirx   lda #$01
         jsr close
         jsr clrchn
         jsr iopause
         rts

         ;read error channel from dev
         ;error# in ioerrnum, text in
         ;iotext
;ioerror  lda #$0f
         ;ldx #$08
         ldy #$0f
         jsr setlfs
         lda #0
         jsr setnam
         jsr open

ioerror  stx iotemp
         jsr clrchn
         ldx iotemp
         jsr chkin

         ldy #0
ioerror0 jsr chrin
         cmp #13
         beq ioerror1
         sta iotext,y
         iny
         bne ioerror0

ioerror1 lda #0
         sta iotext,y
         ;calc error#
         lda iotext
         sec
         sbc #48
         asl a
         sta iotemp
         asl a
         asl a
         clc
         adc iotemp
         sta ioerrnum
         lda iotext+1
         sec
         sbc #48
         clc
         adc ioerrnum
         sta ioerrnum
         jsr clrchn
        ;lda #$0f
        ;jsr close
         lda ioerrnum
         rts

         ;ping device �
         ;Acc negative if no device
ioping   lda #$0f
         ldy #$0f
         jsr setlfs
         lda #0
         jsr setnam
         jsr open
         lda #$0f
         jsr close
         jsr readst
         rts

         ;print decimal number in
         ;ionum to ionum+3
ioprnd   lda #10
         sta ionum+4

         ldy #10
ioprnd1  sty iotemp
         jsr iodiv32
         ldy iotemp
         clc
         adc #48
         sta iotmpc,y
         dey
         bne ioprnd1

ioprnd2  iny
         lda iotmpc,y
         cmp #48
         beq ioprnd2
         cpy #11
         bne ioprnd3
         lda #48
         jsr chrout
         rts
ioprnd3  jsr chrout
         iny
         lda iotmpc,y
         cpy #11
         bne ioprnd3
         rts

         ;divide ionum - ionum+3 by
         ;ionum+4 remainder in a
iodiv32  lda #0
         ldy #$20
iodiv321 asl ionum
         rol ionum+1
         rol ionum+2
         rol ionum+3
         rol a
         cmp ionum+4
         bcc iodiv322
         sbc ionum+4
         inc ionum
iodiv322 dey
         bne iodiv321
         rts

         ;input text
         ;return string in iotext
         ;y = length
ioinput  ldy #$00
         sty blnsw     ;blink on

         .if c128
         lda #$0a
         sta $d600
         bit $d600
         bpl *-3
         lda curmod ;80col cursor
         sta $d601
         .endif

ioinput1 sty iotemp
         jsr getin
         ldy iotemp
         cmp #0
         beq ioinput1
         cmp #13
         beq ioinputx
         cmp #20
         bne ioinput2
         cpy #0
         beq ioinput1
         jsr chrout
         dey
         bpl ioinput1

ioinput2 cmp #32
         bcc ioinput1
         cmp #128
         bcs ioinput1

         sta iotext,y
         jsr chrout
         iny
         cpy #20
         bne ioinput1

ioinputx lda #0
         sta iotext,y
         sta blnon
         lda #32
         sta blnsw   ;blink off
         jsr chrout  ;overwrite cursor

        ;128 80col off
         .if c128
         lda #$0a
         sta $d600
         bit $d600
         bpl *-3
         lda #$20 ;no cursor
         sta $d601
         .endif

         rts

ioprint  ;print whats at yyxx
         ;0 terminated
         stx iozp
         sty iozp+1
         ldy #0
ioprint1 lda (iozp),y
         beq ioprintx
         jsr chrout
         iny
         bne ioprint1
ioprintx rts

         ;wait for key with prompt
iopause  ldx #<iopauset
         ldy #>iopauset
         jsr ioprint
iopause1 jsr getin
         cmp #0
         beq iopause1
         ldx #<iopauseu
         ldy #>iopauseu
         jsr ioprint
         rts

iodollar .text "$"
iopauset .byte $12
         .text "- pause -"
         .byte $92, 0
iopauseu .byte $14, $14, $14, $14, $14
         .byte $14, $14, $14, $14, $14

         .byte 0
ionum    .word 0,0,0
ioerrnum .byte 0
iotemp   .word 0,0
iotmpc   .word 0,0,0,0,0,0
iotext   .text "                    "
         .text "                    "
         .text "strobe'98"

d64it
         ;*= $1000

         ldx #<txtd0
         ldy #>txtd0
         jsr ioprint

        ;lda #0   ; d64
        ;sta intype
        ;lda #1   ; ts
        ;sta outtype

         lda #$01
         sta track
         lda #$00
         sta sector

         ;ldy #$00
         ;lda #$01
         ;sta $d800,y
         ;sta $d900,y
         ;iny
         ;bne *-7

         ;open error channel for 1541
         lda #$0f
         ldx d1541dev
         ldy #$0f
         jsr setlfs
         lda #$00
         jsr setnam
         jsr open

        ;send partition cmd?
         ldx #$0f
         jsr chkout
         lda #67    ;c
         jsr chrout
         lda #80    ;p
         jsr chrout
         lda drive
         asl a
         tay
         lda nums,y
         jsr chrout
         iny
         lda nums,y
         cmp #$20
         beq *+5
         jsr chrout
         lda #$0d
         jsr chrout

        ;read error ch
         ldx #$0f
         jsr ioerror

         ;ldx #<iotext
         ;ldy #>iotext
         ;jsr ioprint
         ;lda #$0d
         ;jsr chrout

         ;set file# for d64 file
         lda #$01
         ldx d64dev
         ldy #$02
         jsr setlfs

         ;create path+name
         ldx #$00
         ldy d64pathl
d64it2   lda d64name,x
         sta d64path,y
         inx
         iny
         cpx d64namel
         bne d64it2

         lda d64mode
         beq d64it3

         lda #$2c
         sta d64path,y
         iny
         lda #$50
         sta d64path,y
         iny
         lda #$2c
         sta d64path,y
         iny
         lda #$57
         sta d64path,y
         iny

d64it3   tya             ;length

         ;open path
         ldx #<d64path
         ldy #>d64path
         jsr setnam
         jsr open

         ;reset 1541 buffer pointer
         lda #$08
         ldx d1541dev
         ldy #$08
         jsr setlfs
         lda #$01
         ldx #<hash
         ldy #>hash
         jsr setnam
         jsr open

         jsr clrchn
         ldx #$0f
         jsr chkout
         lda #66    ;b
         jsr chrout
         lda #45    ;-
         jsr chrout
         lda #80    ;p
         jsr chrout
         lda #58    ;:
         jsr chrout
         lda #56    ;channel 8
         jsr chrout
         lda #44    ;,
         jsr chrout
         lda #48    ;byte 0
         jsr chrout

start    lda #slidebeg
         sta slide+1
         sta slidec+1
         lda #$00
         sta slide
         sta slidec

         jsr clrchn

         jsr getin
         cmp #$03
         bne start0

         ldx #<txtd2
         ldy #>txtd2
         jsr ioprint

         jmp d64exit

start0   lda track
         asl a
         tay
         lda nums,y
         jsr chrout
         iny
         lda nums,y
         jsr chrout
         lda #$9d
         jsr chrout
         lda #$9d
         jsr chrout

instart  jsr clrchn
         lda intype
         bne ints

ind64    ldx #$01
         jsr chkin
         jmp in

ints     ldx #$0f
         jsr chkout
         lda #85    ;u
         jsr chrout
         lda #49    ;1
         jsr chrout
         lda #58    ;:
         jsr chrout
         lda #56    ;channel 8
         jsr chrout
         lda #44    ;,
         jsr chrout

         lda #48   ;drive 0
         jsr chrout
         .if 0
         lda drive
         asl a
         tay
         lda nums,y
         jsr chrout
         iny
         lda nums,y
         cmp #$20
         beq *+5
         jsr chrout
         .endif

         lda #44    ;,
         jsr chrout
         lda track
         asl a
         tay
         lda nums,y
         jsr chrout
         iny
         lda nums,y
         cmp #$20
         beq *+5
         jsr chrout
         lda #44    ;,
         jsr chrout
         lda sector
         asl a
         tay
         lda nums,y
         jsr chrout
         iny
         lda nums,y
         cmp #$20
         beq *+5
         jsr chrout
         jsr clrchn
         ldx #$08
         jsr chkin


in       ldy #$00
fuckit1  jsr chrin
         sta screen+$0280,y
         sta (slide),y
         iny
         bne fuckit1

         inc slide+1
nexts    ldy track
         lda sector
         clc
         adc #$01
         sta sector
         cmp tracks,y
         beq *+5
         jmp instart

         lda #$00
         sta sector

outstart jsr clrchn
         ldx #1
         lda outtype
         beq out
         ldx #8
out      jsr chkout

         ldy #$00
fuckit2  lda (slidec),y
         jsr chrout
         iny
         bne fuckit2

         lda outtype
         beq nextts

         jsr clrchn
         ldx #$0f
         jsr chkout
         lda #85    ;u
         jsr chrout
         lda #50    ;2
         jsr chrout
         lda #58    ;:
         jsr chrout
         lda #56    ;channel 8
         jsr chrout
         lda #44    ;,
         jsr chrout

         lda #48   ;drive 0
         jsr chrout
         .if 0
         lda drive
         asl a
         tay
         lda nums,y
         jsr chrout
         iny
         lda nums,y
         cmp #$20
         beq *+5
         jsr chrout
         .endif

         lda #44    ;,
         jsr chrout
         lda track
         asl a
         tay
         lda nums,y
         jsr chrout
         iny
         lda nums,y
         cmp #$20
         beq *+5
         jsr chrout
         lda #44    ;,
         jsr chrout
         lda sector
         asl a
         tay
         lda nums,y
         jsr chrout
         iny
         lda nums,y
         cmp #$20
         beq *+5
         jsr chrout


nextts   inc sector
         inc slidec+1
         lda slide+1
         cmp slidec+1
         beq *+5
         jmp outstart


         ldy track
         iny
         sty track
         lda #$00
         sta sector

         cpy #36
         beq *+5
         jmp start


         jsr clrchn

        ;finished
         ldx #<txtd1
         ldy #>txtd1
         jsr ioprint


d64exit  lda #$01
         jsr close
         lda #$08
         jsr close
         lda #$0f
         jsr close

         jsr clall

         rts

txtd0    .byte $93, 5
	.text "Converting, Track: "
         .byte 0

txtd1    .byte 13
         .text "Finished!"
         .byte 13
         .byte 0

txtd2    .byte 13
         .text "Aborted!!!"
         .byte 13
         .byte 0

track    .byte 1
sector   .byte 0
drive    .byte 0

intype   .byte 0
outtype  .byte 0

d64mode  .byte 0

d1541dev .byte 0
d64dev   .byte 0
filetype .byte 0

d64namel .byte 10

d64name  .text "strobe.d64      "

hash     .text "#"

nums     .text "0 1 2 3 4 5 6 7 8 9 "
         .text "10111213141516171819"
         .text "20212223242526272829"
         .text "30313233343536373839"
         .text "40414243444546474849"
         .text "50515253545556575859"
         .text "60616263646566676869"
         .text "70717273747576777879"
         .text "80818283848586878889"
         .text "90919293949596979899"

tracks   .byte 21
         .byte 21,21,21,21,21
         .byte 21,21,21,21,21
         .byte 21,21,21,21,21
         .byte 21,21,19,19,19
         .byte 19,19,19,19,18
         .byte 18,18,18,18,18
         .byte 17,17,17,17,17
         .byte 17,17,17,17,17

d64pathl .byte 2
d64path  .text "0:              "
